#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two4004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two4004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two4004xi
#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 400
# -------------------------------------------------------------------------------------------------
shot2two4004xi = {
        1:'0x0y-399z',
        2:'100x-147y-358z',
        3:'105x-138y-359z',
        4:'109x-211y-321z',
        5:'110x-130y-361z',
        6:'111x-3y-384z',
        7:'114x-121y-363z',
        8:'114x-9y-383z',
        9:'116x-381y-32z',
        10:'117x-15y-381z',
        11:'118x-112y-365z',
        12:'118x-202y-323z',
        13:'120x-22y-380z',
        14:'121x-104y-366z',
        15:'122x-29y-379z',
        16:'123x-95y-368z',
        17:'124x-37y-378z',
        18:'125x-86y-369z',
        19:'126x-45y-376z',
        20:'126x-78y-371z',
        21:'127x-193y-326z',
        22:'127x-53y-375z',
        23:'127x-61y-374z',
        24:'127x-69y-372z',
        25:'135x-184y-328z',
        26:'136x-374y-36z',
        27:'142x-174y-330z',
        28:'149x-164y-332z',
        29:'14x-399y-12z',
        30:'155x-153y-335z',
        31:'155x-366y-40z',
        32:'15x-169y-361z',
        33:'15x-262y-301z',
        34:'160x-143y-337z',
        35:'165x-132y-339z',
        36:'169x-121y-341z',
        37:'169x-7y-362z',
        38:'16x-212y-338z',
        39:'172x-110y-343z',
        40:'172x-17y-360z',
        41:'174x-26y-358z',
        42:'174x-357y-44z',
        43:'175x-99y-345z',
        44:'176x-36y-356z',
        45:'176x-88y-347z',
        46:'178x-46y-355z',
        47:'178x-56y-353z',
        48:'178x-67y-351z',
        49:'178x-78y-349z',
        50:'187x-353y0z',
        51:'192x-347y-48z',
        52:'1x-266y-298z',
        53:'206x-342y-3z',
        54:'210x-336y-52z',
        55:'223x-331y-7z',
        56:'227x-324y-56z',
        57:'240x-319y-11z',
        58:'243x-311y-60z',
        59:'24x-164y-363z',
        60:'256x-306y-15z',
        61:'259x-297y-64z',
        62:'26x-207y-340z',
        63:'272x-292y-19z',
        64:'273x-283y-68z',
        65:'287x-268y-72z',
        66:'287x-277y-23z',
        67:'28x-258y-303z',
        68:'300x-252y-75z',
        69:'301x-261y-27z',
        70:'313x-235y-79z',
        71:'314x-245y-31z',
        72:'324x-218y-83z',
        73:'326x-228y-35z',
        74:'32x-159y-365z',
        75:'334x-200y-87z',
        76:'337x-210y-39z',
        77:'343x-182y-91z',
        78:'347x-192y-43z',
        79:'352x-163y-95z',
        80:'356x-174y-47z',
        81:'359x-144y-99z',
        82:'35x-398y-16z',
        83:'365x-125y-103z',
        84:'365x-154y-51z',
        85:'36x-202y-342z',
        86:'370x-106y-107z',
        87:'372x-135y-55z',
        88:'374x-86y-110z',
        89:'377x-66y-114z',
        90:'378x-115y-59z',
        91:'379x-26y-122z',
        92:'379x-46y-118z',
        93:'379x-6y-126z',
        94:'383x-95y-63z',
        95:'386x-103y-1z',
        96:'387x-75y-67z',
        97:'389x-54y-71z',
        98:'391x-13y-79z',
        99:'391x-34y-75z',
        100:'391x-83y-5z',
        101:'394x-62y-9z',
        102:'397x-41y-13z',
        103:'399x-20y-17z',
        104:'39x-154y-366z',
        105:'41x-253y-306z',
        106:'46x-197y-344z',
        107:'54x-248y-309z',
        108:'55x-395y-20z',
        109:'56x-191y-346z',
        110:'58x-185y-460z',
        111:'5x-216y-336z',
        112:'64x-184y-348z',
        113:'66x-241y-311z',
        114:'73x-177y-350z',
        115:'76x-391y-24z',
        116:'77x-235y-314z',
        117:'7x-173y-360z',
        118:'80x-170y-352z',
        119:'87x-163y-354z',
        120:'88x-227y-316z',
        121:'94x-155y-356z',
        122:'96x-387y-28z',
        123:'99x-219y-318z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire400two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire400two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two4004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two4004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two4004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        